package com.huimv.eartag2.eartag.config;

import com.huimv.eartag2.common.mq.Const;
import org.springframework.amqp.core.*;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Configuration
public class TopicRabbitMQConfig {
    //心跳
    @Bean
    public Queue heartbeatQueue() {
        return new Queue(Const.QUEUE_DEVICE_HEARTBEAT);
    }
    //采集器温度
//    @Bean
//    public Queue deviceTempQueue() {
//        return new Queue(Const.QUEUE_DEVICE_TEMP);
//    }
    //耳标数据
//    @Bean
//    public Queue eartagQueue() {
//        return new Queue(Const.QUEUE_EARTAG);
//    }

    //采集器设备交换机
    TopicExchange deviceExchange() {
        return new TopicExchange(Const.EXCHANGE_DEVICE);
    }

    //耳标交换机
//    TopicExchange eartagExchange() {
//        return new TopicExchange(Const.EXCHANGE_EARTAG);
//    }

    //设备交换机、心跳队列、心跳路由键绑定
    @Bean
    Binding bindingHeartbeatExchangeMessage() {
        return BindingBuilder.bind(heartbeatQueue()).to(deviceExchange()).with(Const.ROUTING_KEY_DEVICE_HEARTBEAT);
    }
    //设备交换机、设备环境温度队列、设备环境路由键绑定
//    @Bean
//    Binding bindingDeviceTempExchangeMessage() {
//        return BindingBuilder.bind(deviceTempQueue()).to(deviceExchange()).with(Const.ROUTING_KEY_DEVICE_TEMP);
//    }
    //耳标交换机、耳标队列、耳标路由键绑定
//    @Bean
//    Binding bindingEartagExchangeMessage() {
//        return BindingBuilder.bind(eartagQueue()).to(eartagExchange()).with(Const.ROUTING_KEY_EARTAG);
//    }


  /*  // ============================= 计算小时运动量 ============================= //
    @Bean
    public Queue syncCountActHourQueue() {
        return new Queue(Const.QUEUE_COUNT_ACT_HOUR);
    }
    @Bean
    public  DirectExchange syncCountActHourExchange() {
        return new DirectExchange(Const.EXCHANGE_COUNT_ACT_HOUR);
    }
    @Bean
    public Binding bindingCountActHourExchangeMessage() {
        return BindingBuilder.bind(syncCountActHourQueue()).to(syncCountActHourExchange()).with(Const.ROUTING_KEY_COUNT_ACT_HOUR);
    }

    @Bean
    public Queue eartagFlowQueue() {
        return new Queue(Const.QUEUE_EARTAG_FLOW);
    }
    @Bean
    public  DirectExchange eartagFlowExchange() {
        return new DirectExchange(Const.EXCHANGE_EARTAG_FLOW);
    }
    @Bean
    public Binding bindingeartagFlowExchangeMessage() {
        return BindingBuilder.bind(eartagFlowQueue()).to(eartagFlowExchange()).with(Const.ROUTING_KEY_EARTAG_FLOW);
    }


    // ============================= 更新设备注册信息 ============================= //
    @Bean
    public Queue syncDeviceRegistQueue() {
        return new Queue(Const.QUEUE_DEVICE_REGIST);
    }
    @Bean
    public  DirectExchange syncDeviceRegistExchange() {
        return new DirectExchange(Const.EXCHANGE_DEVICE_REGIST);
    }
    @Bean
    public Binding bindingDeviceRegistExchangeMessage() {
        return BindingBuilder.bind(syncDeviceRegistQueue()).to(syncDeviceRegistExchange()).with(Const.ROUTING_KEY_DEVICE_REGIST);
    }

    // ============================= 更新耳标注册信息 ============================= //
    @Bean
    public Queue syncDartagRegistQueue() {
        return new Queue(Const.QUEUE_EARTAG_REGIST);
    }
    @Bean
    public  DirectExchange synceartagRegistExchange() {
        return new DirectExchange(Const.EXCHANGE_EARTAG_REGIST);
    }
    @Bean
    public Binding bindineartagRegistExchangeMessage() {
        return BindingBuilder.bind(syncDartagRegistQueue()).to(synceartagRegistExchange()).with(Const.ROUTING_KEY_EARTAG_REGIST);
    }


    // ============================= 更新设备在线统计 ============================= //
    @Bean
    public Queue syncdeviceCountQueue() {
        return new Queue(Const.QUEUE_DEVICE_COUNT);
    }
    @Bean
    public  DirectExchange deviceCountExchange() {
        return new DirectExchange(Const.EXCHANGE_DEVICE_COUNT);
    }
    @Bean
    public Binding deviceCountExchangeMessage() {
        return BindingBuilder.bind(syncdeviceCountQueue()).to(deviceCountExchange()).with(Const.ROUTING_KEY_DEVICE_COUNT);
    }

    // ============================= 更新耳标在线统计 ============================= //
    @Bean
    public Queue eartagCountQueue() {
        return new Queue(Const.QUEUE_EARTAG_COUNT);
    }
    @Bean
    public  DirectExchange eartagCountExchange() {
        return new DirectExchange(Const.EXCHANGE_EARTAG_COUNT);
    }
    @Bean
    public Binding eartagCountMessage() {
        return BindingBuilder.bind(eartagCountQueue()).to(eartagCountExchange()).with(Const.ROUTING_KEY_EARTAG_COUNT);
    }


    // ============================= 更新耳标在线状态 ============================= //
    @Bean
    public Queue eartagLiveStatusQueue() {
        return new Queue(Const.QUEUE_EARTAG_LIVE);
    }
    @Bean
    public  DirectExchange eartagLiveStatusExchange() {
        return new DirectExchange(Const.EXCHANGE_EARTAG_LIVE);
    }
    @Bean
    public Binding eartagLiveStatusMessage() {
        return BindingBuilder.bind(eartagLiveStatusQueue()).to(eartagLiveStatusExchange()).with(Const.ROUTING_KEY_EARTAG_LIVE);
    }

    // ============================= 更新耳标设备在线关联统计 ============================= //
    @Bean
    public Queue updateEartagDeviceOnlineCountQueue() {
        return new Queue(Const.QUEUE_EARTAG_DEVICE_ONLINE);
    }
    @Bean
    public  DirectExchange updateEartagDeviceOnlineCountExchange() {
        return new DirectExchange(Const.EXCHANGE_EARTAG_DEVICE_ONLINE);
    }
    @Bean
    public Binding updateEartagDeviceOnlineCountMessage() {
        return BindingBuilder.bind(updateEartagDeviceOnlineCountQueue()).to(updateEartagDeviceOnlineCountExchange()).with(Const.ROUTING_KEY_EARTAG_DEVICE_ONLINE);
    }

    // ============================= 异常统计和异常报警 ============================= //
    @Bean
    public Queue abnormalCountAndAlarmQueue() {
        return new Queue(Const.QUEUE_ABNORMAL);
    }
    @Bean
    public  DirectExchange abnormalCountAndAlarmExchange() {
        return new DirectExchange(Const.EXCHANGE_ABNORMAL);
    }
    @Bean
    public Binding abnormalCountAndAlarmMessage() {
        return BindingBuilder.bind(abnormalCountAndAlarmQueue()).to(abnormalCountAndAlarmExchange()).with(Const.ROUTING_KEY_ABNORMAL);
    }

    // ============================= 判断该设备编号是否存在牧场缓存在线集合当中 ============================= //
    @Bean
    public Queue updateEartagPropertyOfAllStatusQueue() {
        return new Queue(Const.QUEUE_AllSTATUS);
    }
    @Bean
    public  DirectExchange updateEartagPropertyOfAllStatusExchange() {
        return new DirectExchange(Const.EXCHANGE_AllSTATUS);
    }
    @Bean
    public Binding updateEartagPropertyOfAllStatusMessage() {
        return BindingBuilder.bind(updateEartagPropertyOfAllStatusQueue()).to(updateEartagPropertyOfAllStatusExchange()).with(Const.ROUTING_KEY_AllSTATUS);
    }


*/


}
