package com.huimv.eartag2.manage2.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.manage2.pojo.BaseFarm;
import com.huimv.eartag2.manage2.pojo.EartagData;
import com.huimv.eartag2.manage2.pojo.EartagData2;
import com.huimv.eartag2.manage2.service.BaseFarmService;
import com.huimv.eartag2.manage2.service.IEartagData2Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *      牧场基础配置
 * </p>
 *
 * @author zn
 * @since 2022-07-27
 */
@RestController
@RequestMapping("/base-farm")
public class BaseFarmController {
    @Resource
    private BaseFarmService baseFarmService;

    /**
     * @description: 【增加】
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/add")
    public Result addConfig(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> maps){
        return baseFarmService.add(httpServletRequest,maps);
    }

    /**
     * @description: 【删除】
     * @author: 静静
     * @param: ids
     **/
    @PostMapping("/remove")
    public Result removeConfig(@RequestBody String ids){
        return baseFarmService.remove(ids);
    }

    /**
     * @description: 【修改】
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/update")
    public Result updateConfig(@RequestBody  Map<String, String> maps){
        return baseFarmService.update(maps);
    }
    /**
     * @description: 【查询】 分页查询配置表
     * @author: 静静
     * @param: paramsMap
     **/
    @PostMapping("/list")
    public Result list(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return baseFarmService.list(httpServletRequest,paramsMap);
    }
    @Autowired
    IEartagData2Service eartagData;

    @PostMapping("/listAll")
    public List<EartagData> listAll(HttpServletRequest httpServletRequest, @RequestBody Map<String,Integer> paramsMap){
//        return baseFarmService.list(new QueryWrapper<BaseFarm>().eq("farm_code",paramsMap.get("farmCode")));
        return eartagData.list(null);
    }

    @PostMapping("/add1")
    public Boolean add1(HttpServletRequest httpServletRequest, @RequestBody BaseFarm baseFarm){
        boolean save = baseFarmService.save(baseFarm);
        return save;
    }


}

