package com.huimv.eartag2.manage2.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.pojo.EartagData;
import com.huimv.eartag2.manage2.pojo.EartagData2;
import com.huimv.eartag2.manage2.service.IEartagData2Service;
import com.huimv.eartag2.common.common.token.TokenSign;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.manage2.utils.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import com.huimv.eartag2.manage2.utils.Action;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2022-07-29
 */
@RestController
@RequestMapping("/eartagData")
public class EartagData2Controller {
    @Autowired
    private IEartagData2Service eartagDataService;

    @PostMapping("/getActAndEemp")
    public Result getActAndEemp(@RequestBody Map<String, String> maps){

        String starTime = maps.get("starTime");
        String endTime = maps.get("endTime");
        String earmark = maps.get("earmark");
//        String farmId = maps.get("farmId");

        try {
            QueryWrapper<EartagData> eartagData2QueryWrapper = new QueryWrapper<EartagData>().eq("earmark", earmark).between("add_time", starTime, endTime);

            List<Data> data = eartagDataService.getActAndEemp(eartagData2QueryWrapper);


            Action action = new Action(35.5, 5.5, 6.0, 8, 10);
            action.analyze(data);
            List<com.huimv.eartag2.manage2.utils.Result> filter = action.filter(5, 5);
            Map map = new HashMap();
            map.put("results",filter);

            map.put("calc",action.calc());
            return new Result(ResultCode.SUCCESS,map);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return new Result(ResultCode.FAIL,"");
    }


    @PostMapping("/getEnvByTime")
    public Result getEnvByTime(@RequestBody Map<String,String> map, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        map.put("userId",userId+"");
        return eartagDataService.getEnvByTime(map);
    }
    @PostMapping("/getByTimeFilter")
    public Result getByTimeFilter(@RequestBody Map<String,String> map, HttpServletRequest request){
        return eartagDataService.getByTimeFilter(map);
    }
    @PostMapping("/api/getEnvByTime")
    public Result getEnvByTime2(@RequestBody Map<String,String> map, HttpServletRequest request){
        return eartagDataService.getEnvByTime2(map);
    }

    /**
     * @Method      : getEartagDataByEarmark
     * @Description : earmark,startDate,endDate
     * @Params      : [map, request]
     * @Return      : com.huimv.eartag2.common.utils.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/10/15       
     * @Time        : 15:55
     */
    @PostMapping("/api/getEartagDataByEarmark")
    public Result getEartagDataByEarmark(@RequestBody Map<String,String> map, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        map.put("userId",userId+"");
        return eartagDataService.getEartagDataByEarmark(map);
    }

    @PostMapping("/api/eartagData/getTemp")
    public Result getTemp(@RequestBody Map<String,String> map){

        return eartagDataService.getTemp(map);
    }

    @PostMapping("/api/eartagData/getAct")
    public Result getAct(@RequestBody Map<String,String> map){

        return eartagDataService.getAct(map);
    }

    @PostMapping("/api/qingshan/countEartag")
    public Result countEartag(@RequestBody Map<String,String> map){

        return eartagDataService.countEartag(map);
    }
}
