package com.huimv.eartag2.manage2.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.eartag2.manage2.mapper.*;
import com.huimv.eartag2.manage2.pojo.*;
import com.huimv.eartag2.common.dao.entity.EartagAbnormalAlarmEntity;
import com.huimv.eartag2.common.dao.entity.EartagAbnormalCountEntity;
import com.huimv.eartag2.common.dao.repo.EartagAbnormalAlarmEntityRepo;
import com.huimv.eartag2.common.dao.repo.EartagAbnormalCountEntityRepo;
import com.huimv.eartag2.manage2.service.IEartagService;
import lombok.extern.slf4j.Slf4j;
import org.aspectj.weaver.ast.Var;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.sql.Timestamp;
import java.text.ParseException;
import java.util.*;

/**
 * @Project :
 * @Package :
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class EartagServiceImpl implements IEartagService {
    @Autowired
    private BasePigpenMapper basePigpenMapper;
    @Autowired
    private EartagEartagRegister2Mapper eartagEartagRegister2Mapper;
    @Autowired
    private EartagDeviceRegisterMapper eartagDeviceRegisterMapper;
    @Autowired
    private BaseFarmMapper baseFarmMapper;
    @Autowired
    private SysBaseConfigMapper sysBaseConfigMapper;

    @Autowired
    private EartarFarmAllStatusMapper eartarFarmAllStatusMapper;

    @Override
    public void updateEartagLiveStatusAndCount()   {
        List<BaseFarm> baseFarms = baseFarmMapper.selectList(null);
        Integer eartagOff = 120;
        Integer deviceOff = 1440;
        Date now = new Date();
        for (BaseFarm baseFarm : baseFarms) {
            String farmCode = baseFarm.getFarmCode();
            SysBaseConfig baseConfig = sysBaseConfigMapper.selectOne(new QueryWrapper<SysBaseConfig>().eq("config_key", "farmCode").eq("config_value", farmCode));
            if (ObjectUtil.isNotEmpty(baseConfig)){
                SysBaseConfig eartagOffConfig = sysBaseConfigMapper.selectOne(new QueryWrapper<SysBaseConfig>().eq("config_key", "eartagOfflineTime").eq("row_id", baseConfig.getRowId()));
                SysBaseConfig deviceOffConfig = sysBaseConfigMapper.selectOne(new QueryWrapper<SysBaseConfig>().eq("config_key", "deviceOfflineTime").eq("row_id", baseConfig.getRowId()));
                if (ObjectUtil.isNotEmpty(eartagOffConfig)){
                    eartagOff = Integer.parseInt(eartagOffConfig.getConfigValue());;
                }
                if (ObjectUtil.isNotEmpty(deviceOffConfig)){
                    deviceOff = Integer.parseInt(deviceOffConfig.getConfigValue());;
                }
            }
            DateTime eartagOffTime = DateUtil.offsetMinute(now, -eartagOff);
            DateTime deviceOffTime = DateUtil.offsetMinute(now, -deviceOff);
            List<EartagEartagRegister2> eartagEartagRegister2s = eartagEartagRegister2Mapper.selectList(new QueryWrapper<EartagEartagRegister2>().eq("farm_id", farmCode).eq("live_status", 1).le("active_time", eartagOffTime));
            List<EartagDeviceRegister> eartagDeviceRegisters = eartagDeviceRegisterMapper.selectList(new QueryWrapper<EartagDeviceRegister>().eq("farm_id", farmCode).eq("active_status", 1).le("active_time", deviceOffTime));
            for (EartagEartagRegister2 eartagEartagRegister2 : eartagEartagRegister2s) {
                //生成报警，并且设置为离线状态

                String alarmContent = "离线警报:" + eartagEartagRegister2.getPigpenName() + "耳标号[" + eartagEartagRegister2.getEarmark() + "]已离线";
                EartagAbnormalAlarmEntity newEartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
                newEartagAbnormalAlarmEntity.setFarmCode(farmCode);

                newEartagAbnormalAlarmEntity.setAddTime(now);
                newEartagAbnormalAlarmEntity.setAddDate(now);
                newEartagAbnormalAlarmEntity.setAlarmSort(6);
                newEartagAbnormalAlarmEntity.setAlarmType(1);
                newEartagAbnormalAlarmEntity.setAlarmFrom(2);
                newEartagAbnormalAlarmEntity.setContent(alarmContent);
                eartagAbnormalAlarmEntityRepo.saveAndFlush(newEartagAbnormalAlarmEntity);

                eartagEartagRegister2.setActiveStatus(0);
                eartagEartagRegister2.setLiveStatus(0);
                eartagEartagRegister2Mapper.updateById(eartagEartagRegister2);
            }
            for (EartagDeviceRegister eartagDeviceRegister : eartagDeviceRegisters) {
                //生成报警，并且设置为离线状态
                String alarmContent = "离线警报:采集器[" + eartagDeviceRegister.getDeviceCode() + "]已离线";
                EartagAbnormalAlarmEntity newEartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
                newEartagAbnormalAlarmEntity.setFarmCode(farmCode);

                newEartagAbnormalAlarmEntity.setAddTime(now);
                newEartagAbnormalAlarmEntity.setAddDate(now);
                newEartagAbnormalAlarmEntity.setAlarmSort(6);
                newEartagAbnormalAlarmEntity.setAlarmType(2);
                newEartagAbnormalAlarmEntity.setAlarmFrom(1);
                newEartagAbnormalAlarmEntity.setContent(alarmContent);

                eartagDeviceRegister.setActiveStatus(0);
                eartagDeviceRegister.setDeviceStatus(0);
                eartagDeviceRegisterMapper.updateById(eartagDeviceRegister);
                eartagAbnormalAlarmEntityRepo.saveAndFlush(newEartagAbnormalAlarmEntity);
            }


            EartarFarmAllStatus eartarFarmAllStatus = eartarFarmAllStatusMapper.selectOne(new QueryWrapper<EartarFarmAllStatus>().ge("update_time", DateUtil.beginOfDay(now)).eq("farm_id", farmCode));
            QueryWrapper<EartagDeviceRegister> deviceWapper = new QueryWrapper<>();
            QueryWrapper<EartagEartagRegister2> eartagWapper = new QueryWrapper<>();

            deviceWapper.eq("farm_id",farmCode);
            eartagWapper.eq("farm_id",farmCode);
            Long allDevice = eartagDeviceRegisterMapper.selectCount(deviceWapper);
            Long allEartag = eartagEartagRegister2Mapper.selectCount(eartagWapper);
            deviceWapper.eq("active_status",1);
            eartagWapper.eq("live_status",1);
            Long onDevice = eartagDeviceRegisterMapper.selectCount(deviceWapper);
            Long onEartag = eartagEartagRegister2Mapper.selectCount(eartagWapper);

            if (ObjectUtil.isEmpty(eartarFarmAllStatus)){
                eartarFarmAllStatus =  new EartarFarmAllStatus();
                //计算设备状态并更新缓存cache(在线数+1，离线数-1，计算设备在线率)
                eartarFarmAllStatus.setDeviceTotal(allDevice.intValue());
                eartarFarmAllStatus.setDeviceOnline(onDevice.intValue());
                eartarFarmAllStatus.setDeviceOffline((allDevice.intValue()-onDevice.intValue()));
                eartarFarmAllStatus.setDeviceRate(calculatePercentage(onDevice,allDevice));
                eartarFarmAllStatus.setDeviceCancel(0);
                eartarFarmAllStatus.setEartagTotal(allEartag.intValue());
                eartarFarmAllStatus.setFarmId(farmCode);
                eartarFarmAllStatus.setCreateDate(now);
                eartarFarmAllStatus.setEartagOnline(onEartag.intValue());
                eartarFarmAllStatus.setEartagRate(calculatePercentage(onDevice,allDevice));
                eartarFarmAllStatus.setUpdateTime(now);
                //{同步更新牧场总状态缓存相关字段}
                eartarFarmAllStatusMapper.insert(eartarFarmAllStatus);
            }else {
                //计算设备状态并更新缓存cache(在线数+1，离线数-1，计算设备在线率)
                eartarFarmAllStatus.setDeviceTotal(allDevice.intValue());
                eartarFarmAllStatus.setDeviceOnline(onDevice.intValue());
                eartarFarmAllStatus.setDeviceOffline((allDevice.intValue()-onDevice.intValue()));
                eartarFarmAllStatus.setDeviceRate(calculatePercentage(onDevice,allDevice));
                eartarFarmAllStatus.setDeviceCancel(0);
                eartarFarmAllStatus.setEartagTotal(allEartag.intValue());
                eartarFarmAllStatus.setEartagOnline(onEartag.intValue());
                eartarFarmAllStatus.setEartagRate(calculatePercentage(onDevice,allDevice));
                eartarFarmAllStatus.setUpdateTime(now);
                //{同步更新牧场总状态缓存相关字段}
                eartarFarmAllStatusMapper.updateById(eartarFarmAllStatus);

            }
        }






      /*  // {}
        List<BasePigpen> basePigpenList = getUnitByPigpen();
        System.out.println("basePigpenList.size=" + basePigpenList.size());
        if (basePigpenList.size() == 0) {
            System.out.println("单元数为0");
        }
        Timestamp nowTimestamp = new Timestamp(new java.util.Date().getTime());
        long offlineTimeDef = 30;
        Map confMap = new HashMap();
        confMap.put("config_key", "eartagOfflineTime");
        List<SysBaseConfig> configList = SysBaseConfigMapper.selectByMap(confMap);
        for (SysBaseConfig baseConfig : configList) {
            if (configList.size() > 0) {
                offlineTimeDef = Long.valueOf(baseConfig.getConfigValue());
                log.info("耳标离线时间=" + offlineTimeDef);
            } else {
                log.error("耳标离线时间属性未配置.");
            }
            JSONArray offlineJa = new JSONArray();
            List countList = new ArrayList();
            String rowId = baseConfig.getRowId();
            List<SysBaseConfig> sysBaseConfigs = SysBaseConfigMapper.selectList(new QueryWrapper<SysBaseConfig>().eq("config_key", "farmCode").eq("row_id", rowId));

            if (ObjectUtil.isNotEmpty(sysBaseConfigs)){
                String farmCode = sysBaseConfigs.get(0).getConfigValue();
                for (BasePigpen basePigpen : basePigpenList) {
//            System.out.println("basePigpen="+basePigpen);
//                String farmCode = basePigpen.getFarmCode();

                    Integer unitId = basePigpen.getId();
                    String unitName = basePigpen.getPigpenName();
                    String pigpenName = basePigpen.getPigpenName();
                    Map countMap = new HashMap<String, Object>();
                    countList.add(countMap);
                    int onlineTimes = 0;
                    int offlineTimes = 0;
                    StringBuilder onlineSb = new StringBuilder();
                    StringBuilder offlineSb = new StringBuilder();
                    // 用330110002测试
//            if(farmId.trim().equalsIgnoreCase("330110002")){
                    // {读取相关耳标注册记录}
                    List<EartagEartagRegister2> eartagEartagRegister2List = getEartagRegister(farmCode, unitId);
                    if (eartagEartagRegister2List.size() == 0) {
                        System.out.println("该单元没有耳标。");
                    }
                    System.out.println("该单元没有耳标 eartagEartagRegister2List.size=" + eartagEartagRegister2List.size());
                    for (EartagEartagRegister2 eartagEartagRegister2 : eartagEartagRegister2List) {
                        Date lastTime = eartagEartagRegister2.getLastTime();
                        long offlineTimeDiff = nowTimestamp.getTime() - lastTime.getTime();
                        long theMinutes = offlineTimeDiff / (1000 * 60);
                        System.out.println("两个时间离线的时间差为：" + theMinutes);
                        System.out.println("配置好的离线时间" + offlineTimeDef);
                        if (offlineTimeDiff / (1000 * 60) >= offlineTimeDef) {

                            System.out.println("-----开始了离线耳标的循环记录------");
                            if (eartagEartagRegister2.getLiveStatus() == 1) {
                                eartagEartagRegister2.setLiveStatus(0);
                                offlineTimes++;
                                if (offlineSb.length() > 0) {
                                    offlineSb.append(",");
                                }
                                offlineSb.append(eartagEartagRegister2.getEarmark());

                            }

                        } else {
                            eartagEartagRegister2.setLiveStatus(1);
                            onlineTimes++;
                            if (onlineSb.length() > 0) {
                                onlineSb.append(",");
                            }
                            onlineSb.append(eartagEartagRegister2.getEarmark());
                        }
                        eartagEartagRegister2Mapper.updateById(eartagEartagRegister2);
                    }
//            }
                    countMap.put("farmCode", farmCode);
                    countMap.put("unitId", unitId);
                    countMap.put("unitName", unitName);
                    countMap.put("total", onlineTimes + offlineTimes);
                    countMap.put("online", onlineTimes);
                    countMap.put("offline", offlineTimes);
                    countMap.put("onlineEarmark", onlineSb.toString());
                    countMap.put("offlineEarmark", offlineSb.toString());

                    //耳标离线报警
                    if (offlineSb.length() > 0) {
                        JSONObject offlineJo = new JSONObject();
                        offlineJo.put("pigpen", pigpenName + unitName);
                        offlineJo.put("earmark", offlineSb.toString());
                        offlineJo.put("farmCode", farmCode);
                        offlineJa.add(offlineJo);
                    }
                }
                for (int a = 0; a < countList.size(); a++) {
                    Map countMap = (Map) countList.get(a);
                    EartagOnlineStatus eartagOnlineStatus = new EartagOnlineStatus();
                    eartagOnlineStatus.setFarmId(countMap.get("farmCode").toString());
                    eartagOnlineStatus.setUnitId(countMap.get("unitId").toString());
                    eartagOnlineStatus.setUnitName(countMap.get("unitName").toString());
                    eartagOnlineStatus.setTotal(Integer.parseInt(countMap.get("total").toString()));
                    eartagOnlineStatus.setOnline(Integer.parseInt(countMap.get("online").toString()));
                    eartagOnlineStatus.setOffline(Integer.parseInt(countMap.get("offline").toString()));
                    eartagOnlineStatus.setOnlineEarmark(countMap.get("onlineEarmark").toString());
                    eartagOnlineStatus.setOfflineEarmark(countMap.get("offlineEarmark").toString());
                    eartagOnlineStatus.setAddTime(nowTimestamp);
                    eartagOnlineStatusMapper.insert(eartagOnlineStatus);
                }
                //添加异常报警信息
                saveEartagOfflineAlarm(offlineJa);
            }
            }*/


    }
    public static double calculatePercentage(double value1, double value2) {
        if (value2 == 0) {
            return 0.0F;
        } else {
            return  (value1 / value2) * 100 ;
//            return String.format("%.2f%%", percentage);
        }
    }
    /*@Override
    public void updateEartagLiveStatusAndCount() throws ParseException {
        // {}
        List<BasePigpen> basePigpenList =  getUnitByPigpen();
        System.out.println("basePigpenList.size="+basePigpenList.size());
        if(basePigpenList.size() == 0){
            System.out.println("单元数为0");
        }
        Timestamp nowTimestamp = new Timestamp(new java.util.Date().getTime());
        int offlineTimeDef = 30;
        Map confMap = new HashMap();
        confMap.put("config_key","eartagOfflineTime");
        List<SysBaseConfig> configList = SysBaseConfigMapper.selectByMap(confMap);
        if(configList.size()>0){
            offlineTimeDef = Integer.parseInt(configList.get(0).getConfigValue());
            log.info("耳标离线时间="+offlineTimeDef);
        }else{
            log.error("耳标离线时间属性未配置.");
        }
        JSONArray offlineJa = new JSONArray();
        List countList = new ArrayList();
        for(BasePigpen basePigpen:basePigpenList){
//            System.out.println("basePigpen="+basePigpen);
            String farmCode = basePigpen.getFarmCode();
            Integer unitId = basePigpen.getId();
            String unitName = basePigpen.getPigpenName();
            String pigpenName = basePigpen.getPigpenName();
            Map countMap = new HashMap<String,Object>();
            countList.add(countMap);
            int onlineTimes = 0;
            int offlineTimes = 0;
            StringBuilder onlineSb = new StringBuilder();
            StringBuilder offlineSb = new StringBuilder();
            // 用330110002测试
//            if(farmId.trim().equalsIgnoreCase("330110002")){
                // {读取相关耳标注册记录}
                List<EartagEartagRegister2> eartagEartagRegister2List = getEartagRegister(farmCode,unitId);
                if(eartagEartagRegister2List.size() == 0){
                    System.out.println("该单元没有耳标。");
                }
                System.out.println("该单元没有耳标 eartagEartagRegister2List.size="+eartagEartagRegister2List.size());
                for(EartagEartagRegister2 eartagEartagRegister2:eartagEartagRegister2List){
                    Date lastTime = eartagEartagRegister2.getLastTime();
                    long offlineTimeDiff = nowTimestamp.getTime()-lastTime.getTime();
                    if(offlineTimeDiff/(1000*60) >= offlineTimeDef){
                        eartagEartagRegister2.setLiveStatus(0);
                        offlineTimes++;
                        if(offlineSb.length()>0){
                            offlineSb.append(",");
                        }
                        offlineSb.append(eartagEartagRegister2.getEarmark());
                    }else{
                        eartagEartagRegister2.setLiveStatus(1);
                        onlineTimes++;
                        if(onlineSb.length()>0){
                            onlineSb.append(",");
                        }
                        onlineSb.append(eartagEartagRegister2.getEarmark());
                    }
                    eartagEartagRegister2Mapper.updateById(eartagEartagRegister2);
                }
//            }
            countMap.put("farmCode",farmCode);
            countMap.put("unitId",unitId);
            countMap.put("unitName",unitName);
            countMap.put("total",onlineTimes+offlineTimes);
            countMap.put("online",onlineTimes);
            countMap.put("offline",offlineTimes);
            countMap.put("onlineEarmark",onlineSb.toString());
            countMap.put("offlineEarmark",offlineSb.toString());

            //耳标离线报警
            if(offlineSb.length()>0){
                JSONObject offlineJo = new JSONObject();
                offlineJa.add(offlineJo);
                offlineJo.put("pigpen",pigpenName+unitName);
                offlineJo.put("earmark",offlineSb.toString());
                offlineJo.put("farmCode",farmCode);
            }
        }
        for(int a=0;a<countList.size();a++){
            Map countMap = (Map) countList.get(a);
            EartagOnlineStatus eartagOnlineStatus = new EartagOnlineStatus();
            eartagOnlineStatus.setFarmId(countMap.get("farmCode").toString());
            eartagOnlineStatus.setUnitId(countMap.get("unitId").toString());
            eartagOnlineStatus.setUnitName(countMap.get("unitName").toString());
            eartagOnlineStatus.setTotal(Integer.parseInt(countMap.get("total").toString()));
            eartagOnlineStatus.setOnline(Integer.parseInt(countMap.get("online").toString()));
            eartagOnlineStatus.setOffline(Integer.parseInt(countMap.get("offline").toString()));
            eartagOnlineStatus.setOnlineEarmark(countMap.get("onlineEarmark").toString());
            eartagOnlineStatus.setOfflineEarmark(countMap.get("offlineEarmark").toString());
            eartagOnlineStatus.setAddTime(nowTimestamp);
            eartagOnlineStatusMapper.insert(eartagOnlineStatus);
        }
        //添加异常报警信息
        saveEartagOfflineAlarm(offlineJa);
    }*/

    @Autowired
    private EartagAbnormalAlarmEntityRepo eartagAbnormalAlarmEntityRepo;
    @Autowired
    private EartagAbnormalCountEntityRepo eartagAbnormalCountEntityRepo;

    //添加异常报警信息
  /*  public void saveEartagOfflineAlarm(JSONArray offlineJa) throws ParseException {
        String todayDateText = new DateUtil().getTodayDateText();
        java.sql.Date todayDate = new java.sql.Date(new java.util.Date().getTime());
        Timestamp nowTimestamp = new Timestamp(new java.util.Date().getTime());
        //耳标离线:6
        int alarmSort = 6;
        //耳标:2
        int alarmFrom = 2;
        //状态:1
        int alarmType = 1;
        int offlineTimes = 0;
        String farmCode = "";
        //保存警报信息
        for (int a = 0; a < offlineJa.size(); a++) {
            JSONObject offlineJo = offlineJa.getJSONObject(a);
            String pigpen = offlineJo.getString("pigpen");
            String earmark = offlineJo.getString("earmark");
            farmCode = offlineJo.getString("farmCode");
            String[] earmarkArray = earmark.split(",");
            offlineTimes += earmarkArray.length;
            for (int b = 0; b < earmarkArray.length; b++) {
                String alarmContent = "离线警报:" + pigpen + "耳标号[" + earmarkArray[b] + "]已离线";
                EartagAbnormalAlarmEntity newEartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
                newEartagAbnormalAlarmEntity.setFarmCode(farmCode);
                newEartagAbnormalAlarmEntity.setAddTime(nowTimestamp);
                newEartagAbnormalAlarmEntity.setAddDate(todayDate);
                newEartagAbnormalAlarmEntity.setAlarmSort(alarmSort);
                newEartagAbnormalAlarmEntity.setAlarmType(alarmType);
                newEartagAbnormalAlarmEntity.setAlarmFrom(alarmFrom);
                newEartagAbnormalAlarmEntity.setContent(alarmContent);
                eartagAbnormalAlarmEntityRepo.saveAndFlush(newEartagAbnormalAlarmEntity);
            }
        }
        //保存耳标警报次数
        saveEartagOfflineCount(farmCode, offlineTimes, todayDate, nowTimestamp);
    }*/

    //保存耳标警报次数
    private void saveEartagOfflineCount(String farmCode, int offlineTimes, java.sql.Date todayDate, Timestamp nowTimestamp) {
        EartagAbnormalCountEntity eartagAbnormalCountEntity = new EartagAbnormalCountEntity();
        eartagAbnormalCountEntity.setFarmCode(farmCode);
        eartagAbnormalCountEntity.setAddDate(todayDate);
        Example<EartagAbnormalCountEntity> example = Example.of(eartagAbnormalCountEntity);
//        Optional<EartagAbnormalCountEntity> optional = eartagAbnormalCountEntityRepo.findOne(example);
        List<EartagAbnormalCountEntity> all = eartagAbnormalCountEntityRepo.findAll(example);
        if (ObjectUtil.isEmpty(all)) {
            eartagAbnormalCountEntity.setEartagStatusCount(offlineTimes);
            eartagAbnormalCountEntity.setEartagStatusUpateTime(nowTimestamp);
            eartagAbnormalCountEntityRepo.saveAndFlush(eartagAbnormalCountEntity);
        } else {
            EartagAbnormalCountEntity queryEartagAbnormalCountEntity = all.get(0);
            queryEartagAbnormalCountEntity.setEartagStatusCount(offlineTimes);
            queryEartagAbnormalCountEntity.setEartagStatusUpateTime(nowTimestamp);
            eartagAbnormalCountEntityRepo.saveAndFlush(queryEartagAbnormalCountEntity);
        }
    }

    private List<EartagEartagRegister2> getEartagRegister(String farmId, Integer unitId) {
        HashMap paramsMap = new HashMap();
        paramsMap.put("farm_id", farmId);
        paramsMap.put("unit_id", unitId);
        return eartagEartagRegister2Mapper.selectByMap(paramsMap);
    }

    public List<BasePigpen> getUnitByPigpen() {
        QueryWrapper<BasePigpen> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("f_type", "2");
        return basePigpenMapper.selectList(queryWrapper);
    }

}
